commit 3ce55109c3797e4b21410b0a3d089a336458d864
Author: freddy77 <freddy77>
Date:   Thu Aug 20 17:50:05 2009 +0000

    small tds_get_n improve

diff --git a/ChangeLog b/ChangeLog
index 3530cbe..d652de6 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Thu Aug 20 19:49:45 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/read.c: small tds_get_n improve
+
 Thu Aug 20 19:48:56 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/tds/data.c src/tds/token.c src/tds/types.pl:
 	- use iconv on variant
@@ -1751,4 +1754,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2848 2009/08/20 17:49:07 freddy77 Exp $
+$Id: ChangeLog,v 1.2849 2009/08/20 17:50:05 freddy77 Exp $
diff --git a/src/tds/read.c b/src/tds/read.c
index d655cf4..2a38f51 100644
--- a/src/tds/read.c
+++ b/src/tds/read.c
@@ -47,7 +47,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: read.c,v 1.110 2009/05/28 16:23:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: read.c,v 1.111 2009/08/20 17:50:05 freddy77 Exp $");
 
 static int read_and_convert(TDSSOCKET * tds, const TDSICONV * char_conv,
 			    size_t * wire_size, char **outbuf, size_t * outbytesleft);
@@ -289,12 +289,13 @@ tds_get_char_data(TDSSOCKET * tds, char *row_buffer, size_t wire_size, TDSCOLUMN
 void *
 tds_get_n(TDSSOCKET * tds, void *dest, int need)
 {
-	int have;
-
 	assert(need >= 0);
 
-	have = (tds->in_len - tds->in_pos);
-	while (need > have) {
+	for (;;) {
+		int have = tds->in_len - tds->in_pos;
+
+		if (need <= have)
+			break;
 		/* We need more than is in the buffer, copy what is there */
 		if (dest != NULL) {
 			memcpy((char *) dest, tds->in_buf + tds->in_pos, have);
@@ -303,7 +304,6 @@ tds_get_n(TDSSOCKET * tds, void *dest, int need)
 		need -= have;
 		if (tds_read_packet(tds) < 0)
 			return NULL;
-		have = tds->in_len - tds->in_pos;
 	}
 	if (need > 0) {
 		/* get the remainder if there is any */

